#pragma once

#include "v3.h"
#include "ppc.h"

class TMesh {
  V3 *verts, *projVerts;
  V3 *colors, *normals;
  int vertsN;
  unsigned int *connectivity;
  int trianglesN;
  void Project(PPC *ppc);
public:
  TMesh();
  void Initialize();
  void SetAABB(AABB aabb);
  void Allocate();
  void RenderPoints(V3 color, PPC *ppc, 
    FrameBuffer *fb);
  void RenderWireFrame(V3 color, PPC *ppc, 
    FrameBuffer *fb);
  void RenderFilled(V3 color, PPC *ppc, 
    FrameBuffer *fb);
  void Load(char *fname);
  V3 GetCenter();
  void SetCenter(V3 newCenter);
  void TranslateVerts(V3 transv);
  void Scale(float aabbDiagonal);
  void GetAABB(AABB *&aabb);
  void Spin(V3 axis, float thetad);
};